unit SubUnit;

{$mode objfpc}{$H+}

// -----------------------------------------------------------------------------
//
//
//                           latest changes: 2021-05-17
// -----------------------------------------------------------------------------
//
// Where to look at in lazarus sources ?
//
// Code about MDI forms is in lazarus\lcl\include\customform.inc
//
// -----------------------------------------------------------------------------


interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  ComCtrls, Buttons;

type

  { TChildForm }

  TChildForm = class(TForm)
    BitBtnWsNormal: TBitBtn;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    ToolBarTop: TToolBar;
    procedure BitBtnWsNormalClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var {%H-}CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
  private
  public
    IsMaximized : boolean;
  end;


var
  ChildForm: TChildForm;


implementation

{$R *.lfm}



{ TChildForm }
procedure TChildForm.FormCreate(Sender: TObject);
begin
  //ShowMessage( 'MDIChildCount = ' +IntToStr( ChildForm.MDIChildCount));
end;


procedure TChildForm.FormResize(Sender: TObject);
begin
  BitBtnWsNormal.Left:= Self.Width -BitBtnWsNormal.Width -15;
end;


procedure TChildForm.FormWindowStateChange(Sender: TObject);
begin
  IsMaximized:= not IsMaximized;
  if IsMaximized
    then
      begin
        Self.BorderStyle:= bsNone;
        ToolBarTop.Visible:= TRUE;
      end
    else Self.BorderStyle:= bsSizeable;

  if WindowState = wsMaximized then
    begin
      WindowState:= wsNormal;
      SetBounds( 0, 0,
                 TPanel( Self.Parent).Width,// -16,
                 TPanel( Self.Parent).Height);// -39);
    end;
end;


procedure TChildForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  // reject from parent  ( here it's name is MDIsimulatorPanel )
  Self.Visible:= FALSE;
  Self.Parent:= NIL;
end;


procedure TChildForm.BitBtnWsNormalClick(Sender: TObject);
begin
  if IsMaximized then
    begin
      DisableAlign;
      WindowState:= wsNormal;
      Self.BorderStyle:= bsSizeable;
      IsMaximized:= FALSE;
      SetBounds( 0, 0,
                 Self.Width -16,
                 Self.Height -39);
      ToolBarTop.Visible:= FALSE;
      EnableAlign;
    end;
end;


end.

